<template>
  <a-card :bordered='false'>
    <div class='table-page-search-wrapper'>
      <a-form layout='inline'>
        <a-row :gutter='48'>
          <a-col :md='5' :sm='15'>
            <a-form-item label='主题'>
              <a-input placeholder='请输入主题' v-model='queryParam.title' />
            </a-form-item>
          </a-col>
          <a-col :md='5' :sm='15'>
            <a-form-item label='预约状态'>
              <a-input placeholder='请输入预约状态' v-model='queryParam.stauts' />
            </a-form-item>
          </a-col>
          <a-col :md='5' :sm='15'>
            <a-form-item label='订单号'>
              <a-input placeholder='请输入订单号' v-model='queryParam.oderNumber' />
            </a-form-item>
          </a-col>
          <a-col :md='8' :sm='24'>
            <span class='table-page-search-submitButtons'>
              <a-button type='primary' @click='$refs.table.refresh(true)'>查询</a-button>
              <a-button style='margin-left: 8px' @click='() => queryParam = {}'>重置</a-button>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>
    <div class='table-operator'>
      <a-button v-if='addEnable' type='primary' icon='plus' @click='$refs.modal.add()'>会议预约</a-button>
      <a-dropdown v-if='removeEnable&&selectedRowKeys.length > 0'>
        <a-button type='danger' icon='delete' @click='delByIds(selectedRowKeys)'>删除</a-button>
      </a-dropdown>
    </div>
    <s-table
      size='default'
      ref='table'
      rowKey='id'
      :rowSelection='{selectedRowKeys: selectedRowKeys, onChange: onSelectChange}'
      :columns='columns'
      :data='loadData'
    >
      <span slot='action' slot-scope='text, record'>
        <a @click='handleInfo(record)'>详情</a>
        <a-divider type='vertical' />
        <a v-if='editEnabel' @click='handleEdit(record)'>编辑</a>
        <a-divider type='vertical' />
        <a v-if='removeEnable' @click='delByIds([record.id])'>删除</a>
         <a-tag v-if='record.statusValue == 0' color='green'>通过</a-tag>
         <a-tag v-if='record.statusValue == 0 || record.statusValue == 1' color='volcano'>驳回</a-tag>
      </span>
    </s-table>
    <reservation-modal ref='modal' @ok='handleOk' />
  </a-card>
</template>

<script>
import { STable } from '@/components'

import { delReservation, getReservationList } from '@/api/admin/meeting/reservation'
import ReservationModal from './modules/ReservationModal.vue'
import { checkPermission } from '@/utils/permissions'

export default {
  name: 'TableList',
  components: {
    STable,
    ReservationModal
  },
  data() {
    return {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 5 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 }
      },
      form: this.$form.createForm(this),
      mdl: {},
      // 高级搜索 展开/关闭
      advanced: false,
      // 查询参数
      queryParam: {},
      // 表头
      columns: [
        {
          title: '会议名称',
          dataIndex: 'title'
        },
        {
          title: '会议室名称',
          dataIndex: 'roomContent.meetingName'
        },
        {
          title: '会议类型',
          dataIndex: 'roomContent.typeName'
        },
        {
          title: '预约人',
          dataIndex: 'userName'
        },
        {
          title: '所属公司',
          dataIndex: 'customerName'
        },
        {
          title: '会议开始时间',
          dataIndex: 'startTime'
        },
        {
          title: '会议结束时间',
          dataIndex: 'endDate'
        },
        {
          title: '时长',
          dataIndex: 'roomContent.duration'
        },
        {
          title: '金额',
          dataIndex: 'orderMoney'
        },
        {
          title: '预约状态',
          dataIndex: 'statusName'
        },
        {
          title: '操作',
          width: '100px',
          dataIndex: 'action',
          scopedSlots: { customRender: 'action' }
        }
      ],
      // 加载数据方法 必须为 Promise 对象
      loadData: parameter => {
        return getReservationList(Object.assign(parameter, this.queryParam))
      },
      selectedRowKeys: [],
      selectedRows: [],
      addEnable: checkPermission('meeting:reservation:add'),
      editEnabel: checkPermission('meeting:reservation:edit'),
      removeEnable: checkPermission('meeting:reservation:remove')
    }
  },
  filters: {},
  created() {
  },
  methods: {
    onSelectChange(selectedRowKeys, selectedRows) {
      this.selectedRowKeys = selectedRowKeys
      this.selectedRows = selectedRows
    },
    //详情，跳转页面
    handleInfo(record) {
      this.$router.push({ name: 'reservationInfo', query: { id: record.id } })

    },
    handleAdd() {
      this.$refs.modal.add()
    },
    handleEdit(record) {
      this.$refs.modal.edit(record)
    },
    handleOk() {
      this.$refs.table.refresh(true)
      console.log('handleSaveOk')
    },
    delByIds(ids) {
      delReservation({ ids: ids.join(',') }).then(res => {
        if (res.code === 0) {
          this.$message.success('删除成功')
          this.handleOk()
        } else {
          this.$message.error(res.msg)
        }
        this.selectedRowKeys = []
      })
    }
  },
  watch: {
    /*
      'selectedRows': function (selectedRows) {
        this.needTotalList = this.needTotalList.map(item => {
          return {
            ...item,
            total: selectedRows.reduce( (sum, val) => {
              return sum + val[item.dataIndex]
            }, 0)
          }
        })
      }
      */
  }
}
</script>
